/* minish.c - example of a minimalistic shell 
 * Comments in code deliberately omitted. :-)
 *
 * [ Lainattu Kyttjrjestelmt -kurssille 2007 esimerkkin shellin
 *   perusideasta ja Unixin fork() -komennon kytst.
 * 
 *   Muokattu kevll 2014: siirretty komentomerkkijonon lukeminen
 *   omaan aliohjelmaansa, jotta pohjelma nyttisi selkemmlt.
 *   Poistettu tarkistuksia, kommenttirivin mahdollisuus ja siisti
 *   exit-poistuminen samasta syyst.
 *
 *   Alkuperinen koodi on Tapani Tarvaisen kurssimateriaalista "UNIX
 *   ja shell-ohjelmointi" (pyynnst saatu kyttlupa kesn 2007
 *   kyttjrjestelmkurssille). Tarkempia kommentteja koodissa ei
 *   ole, koska tm on Tapanin kurssin tehtvmateriaalia ja
 *   perinteinen tenttikysymys mys Kyttjrjestelmt -kurssilla
 *   (...kommentoimaton koodi annetaan, ja toiminta on
 *   selitettv). Trke kohta ovat fork() ja execve() -kutsut: mit
 *   ne tekevt, ja miten forkin paluuarvoa tulkitaan. Lisksi
 *   tietysti wait().
 *
 *   Terveisin Paavo 2007-06-05, 2014-04-01. ]
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/wait.h>
#define MAXLINE 30

/** Apufunktio; "paloittelee" syterivin vlilyntien kohdalta. */
void palastele_rivi(char *line, int max_line, char **args){
  char *p, **arg;
  if ((p = strchr(line, '\n'))<(line+max_line)) {
    *p=0; 
  } else { 
    fprintf(stderr, "line too long\n"); 
    exit(1); 
  }
  p = line;
  while (*p == ' ') 
    ++p;
  *(arg=args) = p;           
  while ((p = strchr(p, ' '))) {
    while (*p == ' ') 
      *p++ = 0;
    if (*p) 
      *++arg=p;
  }
  *++arg=NULL;
}

/** Apufunktio; suomenkielinen kre syterivin lukijalle */
void lue_komentorivi(char *line, int maxline){
  fgets(line, maxline, stdin);
}

/** Pohjelma: Miniatyyrikuori. */
int main(int argc, char **argv)
{
  char line[MAXLINE+1], *args[MAXLINE];
  pid_t pid;

  /* Alla oleva ptk on olennaisesti sama "pseudoversio" kuin
   * luentomonisteessa (ilman virhetarkistuksia,
   * poistumismahdollisuutta ja muita oikeasti trkeit piirteit):
   */
  while(1){
    lue_komentorivi(line, MAXLINE);
    palastele_rivi(line, MAXLINE, args);

    pid = fork();
    if (pid==0) {
      execvp(args[0], args);
    } else if (pid == -1) {
      perror("fork() failed");
    } else {
      wait(NULL);
    } 
  }
  
  exit(0);
}
